using System;
using System.Threading.Tasks;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Logging;
using System.Linq;
using Sockeye.Util;
using Sockeye.Api.ControllerHelpers;
using Sockeye.Models;
using Newtonsoft.Json.Linq;
using System.Collections.Generic;
using Newtonsoft.Json;

namespace Sockeye.Biz
{
    internal class ProductBiz : BizObject, IJobObject, ISearchAbleObject, IReportAbleObject, IExportAbleObject, INotifiableObject
    {
        internal ProductBiz(AyContext dbcontext, long currentUserId, long userTranslationId, AuthorizationRoles UserRoles)
        {
            ct = dbcontext;
            UserId = currentUserId;
            UserTranslationId = userTranslationId;
            CurrentUserRoles = UserRoles;
            BizType = SockType.Product;
        }

        internal static ProductBiz GetBiz(AyContext ct, Microsoft.AspNetCore.Http.HttpContext httpContext = null)
        {
            if (httpContext != null)
                return new ProductBiz(ct, UserIdFromContext.Id(httpContext.Items), UserTranslationIdFromContext.Id(httpContext.Items), UserRolesFromContext.Roles(httpContext.Items));
            else
                return new ProductBiz(ct, 1, ServerBootConfig.SOCKEYE_DEFAULT_TRANSLATION_ID, AuthorizationRoles.BizAdmin);
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////
        //EXISTS 
        internal async Task<bool> ExistsAsync(long id)
        {
            return await ct.Product.AnyAsync(z => z.Id == id);
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////
        //CREATE   
        //
        internal async Task<Product> CreateAsync(Product newObject)
        {
            await ValidateAsync(newObject, null);
            if (HasErrors)
                return null;
            else
            {
                newObject.Tags = TagBiz.NormalizeTags(newObject.Tags);
                await ct.Product.AddAsync(newObject);
                await ct.SaveChangesAsync();
                await EventLogProcessor.LogEventToDatabaseAsync(new Event(UserId, newObject.Id, BizType, SockEvent.Created), ct);
                await SearchIndexAsync(newObject, true);
                await TagBiz.ProcessUpdateTagsInRepositoryAsync(ct, newObject.Tags, null);
                await HandlePotentialNotificationEvent(SockEvent.Created, newObject);
                return newObject;
            }
        }



        ////////////////////////////////////////////////////////////////////////////////////////////////
        //GET 
        //      
        internal async Task<Product> GetAsync(long id, bool logTheGetEvent = true)
        {
            var ret = await ct.Product.AsNoTracking().SingleOrDefaultAsync(z => z.Id == id);
            if (logTheGetEvent && ret != null)
                await EventLogProcessor.LogEventToDatabaseAsync(new Event(UserId, id, BizType, SockEvent.Retrieved), ct);
            return ret;
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////
        //UPDATE
        //
        internal async Task<Product> PutAsync(Product putObject)
        {
            var dbObject = await GetAsync(putObject.Id, false);
            if (dbObject == null)
            {
                AddError(ApiErrorCode.NOT_FOUND, "id");
                return null;
            }
            if (dbObject.Concurrency != putObject.Concurrency)
            {
                AddError(ApiErrorCode.CONCURRENCY_CONFLICT);
                return null;
            }

            putObject.Tags = TagBiz.NormalizeTags(putObject.Tags);
            await ValidateAsync(putObject, dbObject);
            if (HasErrors) return null;
            ct.Replace(dbObject, putObject);
            try
            {
                await ct.SaveChangesAsync();
            }
            catch (DbUpdateConcurrencyException)
            {
                if (!await ExistsAsync(putObject.Id))
                    AddError(ApiErrorCode.NOT_FOUND);
                else
                    AddError(ApiErrorCode.CONCURRENCY_CONFLICT);
                return null;
            }
            await EventLogProcessor.LogEventToDatabaseAsync(new Event(UserId, putObject.Id, BizType, SockEvent.Modified), ct);
            await SearchIndexAsync(putObject, false);
            await TagBiz.ProcessUpdateTagsInRepositoryAsync(ct, putObject.Tags, dbObject.Tags);
            await HandlePotentialNotificationEvent(SockEvent.Modified, putObject, dbObject);
            return putObject;
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////
        //DELETE
        //
        internal async Task<bool> DeleteAsync(long id)
        {
            using (var transaction = await ct.Database.BeginTransactionAsync())
            {

                Product dbObject = await GetAsync(id, false);
                if (dbObject == null)
                {
                    AddError(ApiErrorCode.NOT_FOUND);
                    return false;
                }
                await ValidateCanDeleteAsync(dbObject);
                if (HasErrors)
                    return false;




                {
                    var IDList = await ct.Review.AsNoTracking().Where(x => x.SockType == SockType.Product && x.ObjectId == id).Select(x => x.Id).ToListAsync();
                    if (IDList.Count() > 0)
                    {
                        ReviewBiz b = new ReviewBiz(ct, UserId, UserTranslationId, CurrentUserRoles);
                        foreach (long ItemId in IDList)
                            if (!await b.DeleteAsync(ItemId, transaction))
                            {
                                AddError(ApiErrorCode.CHILD_OBJECT_ERROR, null, $"Review [{ItemId}]: {b.GetErrorsAsString()}");
                                return false;
                            }
                    }
                }

                ct.Product.Remove(dbObject);
                await ct.SaveChangesAsync();

                //Log event 
                await EventLogProcessor.DeleteObjectLogAsync(UserId, BizType, dbObject.Id, dbObject.Name, ct);
                await Search.ProcessDeletedObjectKeywordsAsync(dbObject.Id, BizType, ct);
                await TagBiz.ProcessDeleteTagsInRepositoryAsync(ct, dbObject.Tags);
                await FileUtil.DeleteAttachmentsForObjectAsync(BizType, dbObject.Id, ct);
                await transaction.CommitAsync();
                await HandlePotentialNotificationEvent(SockEvent.Deleted, dbObject);

                return true;
            }
        }


        ////////////////////////////////////////////////////
        // UTILITY
        //
        public static ProductGroup ProductGroupFromProductCode(string productCode)
        {
            switch (productCode)
            {
                case "300740321"://wbi
                case "300740317"://up to 5
                case "300740314"://RI
                case "300740328"://Quick notification
                case "300784766"://QBOI
                case "300740315"://Single
                case "300740323"://QBI
                case "300740318"://Up to 10
                case "300740327"://Export to XLS
                case "300740329"://ImportExport CSV duplicate
                case "300740319"://Up to 20
                case "300740322"://MBI
                case "300740324"://PTI
                case "300740325"://OLI
                case "300807973"://Up to 15
                case "300740326"://Outlook Schedule Export
                case "300740316"://AyaNova LITE
                case "999"://Up to 999
                    return ProductGroup.AyaNova7;
                case "300093112"://Key administration               
                case "301010670"://Custom 733918243
                case "300151145"://Custom 539230073
                    return ProductGroup.Misc;
                case "301028317"://AyaNova perpetual single user  license includes one year maintenance plan            
                    return ProductGroup.RavenPerpetual;
                case "301028468"://AyaNova subscription one user YEARLY        
                case "301028467"://AyaNova subscription one user MONTHLY    
                    return ProductGroup.RavenSubscription;
                default:
                    throw new Exception($"Uknown product code {productCode}");
            }
        }
        /*
        "id"	"name"	"active"	"vendorid"	"licenseinterval"	"maintinterval"	"vendorcode"	"ourcode"	"wiki"	"tags"
1	"WBI"	true	1	"00:00:00"	"365 days"	"300740321"	"300740321"		"{}"
2	"Up to 5"	true	1	"00:00:00"	"365 days"	"300740317"	"300740317"		"{}"
3	"RI"	true	1	"00:00:00"	"365 days"	"300740314"	"300740314"		"{}"
4	"Quick Notification"	true	1	"00:00:00"	"365 days"	"300740328"	"300740328"		"{}"
5	"QBOI"	true	1	"00:00:00"	"365 days"	"300784766"	"300784766"		"{}"
6	"Single"	true	1	"00:00:00"	"365 days"	"300740315"	"300740315"		"{}"
7	"QBI"	true	1	"00:00:00"	"365 days"	"300740323"	"300740323"		"{}"
8	"Up to 10"	true	1	"00:00:00"	"365 days"	"300740318"	"300740318"		"{}"
9	"Export to  XLS"	true	1	"00:00:00"	"365 days"	"300740327"	"300740327"		"{}"
10	"Importexport.csv duplicate"	true	1	"00:00:00"	"365 days"	"300740329"	"300740329"		"{}"
11	"Up to 20"	true	1	"00:00:00"	"365 days"	"300740319"	"300740319"		"{}"
12	"MBI"	true	1	"00:00:00"	"365 days"	"300740322"	"300740322"		"{}"
13	"Key Administration"	true	1	"00:00:00"	"365 days"	"300093112"	"300093112"		"{}"
14	"PTI "	true	1	"00:00:00"	"365 days"	"300740324"	"300740324"		"{}"
15	"OLI"	true	1	"00:00:00"	"365 days"	"300740325"	"300740325"		"{}"
16	"Up to 15"	true	1	"00:00:00"	"365 days"	"300807973"	"300807973"		"{}"
17	"Outlook Schedule Export"	true	1	"00:00:00"	"365 days"	"300740326"	"300740326"		"{}"
18	"AyaNova Lite"	true	1	"00:00:00"	"365 days"	"300740316"	"300740316"		"{}"
19	"Up to 999"	true	1	"00:00:00"	"365 days"	"999"	"999"		"{}"
20	"AyaNova perpetual single user  license includes one year maintenance plan"	true	1	"00:00:00"	"365 days"	"301028317"	"301028317"		"{}"
21	"Custom 733918243"	true	1	"00:00:00"	"365 days"	"301010670"	"301010670"		"{}"
22	"AyaNova subscription one user  monthly"	true	1	"31 days"	"31 days"	"301028467"	"301028467"		"{}"
23	"Custom 539230073"	true	1	"00:00:00"	"365 days"	"300151145"	"300151145"		"{}"
24	"AyaNova subscription one user  yearly"	true	1	"365 days"	"365 days"	"301028468"	"301028468"		"{}"
        */

        ////////////////////////////////////////////////////////////////////////////////////////////////
        //SEARCH
        //
        private async Task SearchIndexAsync(Product obj, bool isNew)
        {
            var SearchParams = new Search.SearchIndexProcessObjectParameters(UserTranslationId, obj.Id, BizType);
            DigestSearchText(obj, SearchParams);
            if (isNew)
                await Search.ProcessNewObjectKeywordsAsync(SearchParams);
            else
                await Search.ProcessUpdatedObjectKeywordsAsync(SearchParams);
        }

        public async Task<Search.SearchIndexProcessObjectParameters> GetSearchResultSummary(long id, SockType specificType)
        {
            var obj = await GetAsync(id, false);
            var SearchParams = new Search.SearchIndexProcessObjectParameters();
            DigestSearchText(obj, SearchParams);
            return SearchParams;
        }

        public void DigestSearchText(Product obj, Search.SearchIndexProcessObjectParameters searchParams)
        {
            if (obj != null)
                searchParams.AddText(obj.VendorCode)
                            .AddText(obj.Name)
                            .AddText(obj.Wiki)
                            .AddText(obj.Tags)
                            .AddText(obj.OurCode);
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////
        //VALIDATION
        //

        private async Task ValidateAsync(Product proposedObj, Product currentObj)
        {
            await Task.CompletedTask;

        }


        private async Task ValidateCanDeleteAsync(Product inObj)
        {
            if (await ct.Purchase.AnyAsync(m => m.ProductId == inObj.Id))
                AddError(ApiErrorCode.VALIDATION_REFERENTIAL_INTEGRITY, "generalerror", await Translate("Purchase"));
        }


        ////////////////////////////////////////////////////////////////////////////////////////////////
        //REPORTING
        //
        public async Task<JArray> GetReportData(DataListSelectedRequest dataListSelectedRequest, Guid jobId)
        {
            var idList = dataListSelectedRequest.SelectedRowIds;
            JArray ReportData = new JArray();
            while (idList.Any())
            {
                var batch = idList.Take(IReportAbleObject.REPORT_DATA_BATCH_SIZE);
                idList = idList.Skip(IReportAbleObject.REPORT_DATA_BATCH_SIZE).ToArray();

                //query for this batch, comes back in db natural order unfortunately
                var batchResults = await ct.Product.AsNoTracking().Where(z => batch.Contains(z.Id)).ToArrayAsync();

                //order the results back into original
                //What is happening here:
                //for performance the query is batching a bunch at once by fetching a block of items from the sql server
                //however it's returning in db order which is often not the order the id list is in
                //so it needs to be sorted back into the same order as the ide list
                //This would not be necessary if just fetching each one at a time individually (like in workorder get report data)

                var orderedList = from id in batch join z in batchResults on id equals z.Id select z;
                batchResults = null;

                foreach (Product w in orderedList)
                {
                    if (!ReportRenderManager.KeepGoing(jobId)) return null;

                    var jo = JObject.FromObject(w);
                    if (!JsonUtil.JTokenIsNullOrEmpty(jo["CustomFields"]))
                        jo["CustomFields"] = JObject.Parse((string)jo["CustomFields"]);
                    ReportData.Add(jo);
                }
                orderedList = null;
            }
            vc.Clear();
            return ReportData;
        }
        private VizCache vc = new VizCache();




        ////////////////////////////////////////////////////////////////////////////////////////////////       
        // IMPORT EXPORT
        //

        public async Task<JArray> GetExportData(DataListSelectedRequest dataListSelectedRequest, Guid jobId)
        {
            return await GetReportData(dataListSelectedRequest, jobId);
        }


        ////////////////////////////////////////////////////////////////////////////////////////////////
        //JOB / OPERATIONS
        //
        public async Task HandleJobAsync(OpsJob job)
        {
            //Hand off the particular job to the corresponding processing code
            //NOTE: If this code throws an exception the caller (JobsBiz::ProcessJobsAsync) will automatically set the job to failed and log the exeption so 
            //basically any error condition during job processing should throw up an exception if it can't be handled
            switch (job.JobType)
            {
                case JobType.BatchCoreObjectOperation:
                    await ProcessBatchJobAsync(job);
                    break;
                default:
                    throw new System.ArgumentOutOfRangeException($"ProductBiz.HandleJob-> Invalid job type{job.JobType.ToString()}");
            }
        }



        private async Task ProcessBatchJobAsync(OpsJob job)
        {
            await JobsBiz.UpdateJobStatusAsync(job.GId, JobStatus.Running);
            await JobsBiz.LogJobAsync(job.GId, $"LT:StartJob {job.SubType}");
            List<long> idList = new List<long>();
            long FailedObjectCount = 0;
            JObject jobData = JObject.Parse(job.JobInfo);
            if (jobData.ContainsKey("idList"))
                idList = ((JArray)jobData["idList"]).ToObject<List<long>>();
            else
                idList = await ct.Product.AsNoTracking().Select(z => z.Id).ToListAsync();
            bool SaveIt = false;

            //---------------------------------
            //case 4192
            TimeSpan ProgressAndCancelCheckSpan = new TimeSpan(0, 0, ServerBootConfig.JOB_PROGRESS_UPDATE_AND_CANCEL_CHECK_SECONDS);
            DateTime LastProgressCheck = DateTime.UtcNow.Subtract(new TimeSpan(1, 1, 1, 1, 1));
            var TotalRecords = idList.LongCount();
            long CurrentRecord = -1;
            //---------------------------------

            foreach (long id in idList)
            {
                try
                {
                    //--------------------------------
                    //case 4192
                    //Update progress / cancel requested?                    
                    CurrentRecord++;
                    if (DateUtil.IsAfterDuration(LastProgressCheck, ProgressAndCancelCheckSpan))
                    {
                        await JobsBiz.UpdateJobProgressAsync(job.GId, $"{CurrentRecord}/{TotalRecords}");
                        if (await JobsBiz.GetJobStatusAsync(job.GId) == JobStatus.CancelRequested)
                            break;
                        LastProgressCheck = DateTime.UtcNow;
                    }
                    //---------------------------------

                    SaveIt = false;
                    ClearErrors();
                    Product o = null;
                    //save a fetch if it's a delete
                    if (job.SubType != JobSubType.Delete)
                        o = await GetAsync(id, false);
                    switch (job.SubType)
                    {
                        case JobSubType.TagAddAny:
                        case JobSubType.TagAdd:
                        case JobSubType.TagRemoveAny:
                        case JobSubType.TagRemove:
                        case JobSubType.TagReplaceAny:
                        case JobSubType.TagReplace:
                            SaveIt = TagBiz.ProcessBatchTagOperation(o.Tags, (string)jobData["tag"], jobData.ContainsKey("toTag") ? (string)jobData["toTag"] : null, job.SubType);
                            break;
                        case JobSubType.Delete:
                            if (!await DeleteAsync(id))
                            {
                                await JobsBiz.LogJobAsync(job.GId, $"LT:Errors {GetErrorsAsString()} id {id}");
                                FailedObjectCount++;
                            }
                            break;
                        default:
                            throw new System.ArgumentOutOfRangeException($"ProcessBatchJobAsync -> Invalid job Subtype{job.SubType}");
                    }
                    if (SaveIt)
                    {
                        o = await PutAsync(o);
                        if (o == null)
                        {
                            await JobsBiz.LogJobAsync(job.GId, $"LT:Errors {GetErrorsAsString()} id {id}");
                            FailedObjectCount++;
                        }
                    }

                    //delay so we're not tying up all the resources in a tight loop
                    await Task.Delay(Sockeye.Util.ServerBootConfig.JOB_OBJECT_HANDLE_BATCH_JOB_LOOP_DELAY);
                }
                catch (Exception ex)
                {
                    await JobsBiz.LogJobAsync(job.GId, $"LT:Errors id({id})");
                    await JobsBiz.LogJobAsync(job.GId, ExceptionUtil.ExtractAllExceptionMessages(ex));
                }
            }

            //---------------------------------
            //case 4192
            await JobsBiz.UpdateJobProgressAsync(job.GId, $"{++CurrentRecord}/{TotalRecords}");
            //---------------------------------

            await JobsBiz.LogJobAsync(job.GId, $"LT:BatchJob {job.SubType} {idList.Count}{(FailedObjectCount > 0 ? " - LT:Failed " + FailedObjectCount : "")}");
            await JobsBiz.UpdateJobStatusAsync(job.GId, JobStatus.Completed);
        }






        ////////////////////////////////////////////////////////////////////////////////////////////////
        // NOTIFICATION PROCESSING
        //
        public async Task HandlePotentialNotificationEvent(SockEvent ayaEvent, ICoreBizObjectModel proposedObj, ICoreBizObjectModel currentObj = null)
        {
            if (ServerBootConfig.MIGRATING) return;
            ILogger log = Sockeye.Util.ApplicationLogging.CreateLogger<ProductBiz>();

            log.LogDebug($"HandlePotentialNotificationEvent processing:  [SockType:{this.BizType}, AyaEvent:{ayaEvent}]");

            bool isNew = currentObj == null;

            //STANDARD EVENTS FOR ALL OBJECTS
            await NotifyEventHelper.ProcessStandardObjectEvents(ayaEvent, proposedObj, ct);

            //SPECIFIC EVENTS FOR THIS OBJECT
            Product o = (Product)proposedObj;

            //## DELETED EVENTS
            //any event added below needs to be removed, so
            //just blanket remove any event for this object of eventtype that would be added below here
            //do it regardless any time there's an update and then
            //let this code below handle the refreshing addition that could have changes           
            //await NotifyEventHelper.ClearPriorEventsForObject(ct, SockType.Product, o.Id, NotifyEventType.ContractExpiring);


            //## CREATED / MODIFIED EVENTS
            if (ayaEvent == SockEvent.Created || ayaEvent == SockEvent.Modified)
            {



            }

        }//end of process notifications


        /////////////////////////////////////////////////////////////////////

    }//eoc


}//eons

